//+------------------------------------------------------------------+
//|                                                        Nero2.mq4 |
//|                                                     Vetrov F. A. |
//|                                           http://www.nothere.net |
//+------------------------------------------------------------------+
#property copyright "Vetrov F. A."
#property link      "http://www.nothere.net"

//--------------------------      -----------------------

extern int in          = 8;          //         (  99)
extern int hid         = 2;           //     
extern int out         = 1;           //     

bool       IsInit      = 0;           //   
int        Epoha;

double Dhid[][100];
double Dout[];
double Whid[][100];
double Wout[];
double CorrHid[][100];
double SquarHid[][100];
double CorrOut[];
double SquarOut[];

//--------------   -----------------------------
double OUT(int bar = 0)
{
   int i;
   double res = 0.0;
   
   if(!IsInit)
      return(0.0);
      
   for( i= 0; i < hid; i++ )
      Hidden(i,bar);
      
   for( i = 0; i < hid+1; i++)
      res += Dout[i] * Wout[i];
         
   return(th(res));    
}

//---------------    ------------------------
void Hidden(int num, int bar = 0)
{
   int i;
   double res = 0.0;
   
   GetIn(num,bar);   
     
   for(i = 0; i < in+1; i++)
      res += Dhid[num,i] * Whid[num,i];
      
   Dout[num+1] = th(res);   
   return;
}
//---------------------------------------------------------------
//                 
//---------------------------------------------------------------

//------------------  -------------------------------
double th(double x)
{ 
    double res; 
    
    if(MathAbs(x)<100.0)
       res=(MathExp(x)-MathExp(-x))/(MathExp(x)+MathExp(-x));
    else 
       res=MathAbs(x)/x;
    return(res);
} 

//------------------    --------------
void GetIn( int num, int bar, double kf = 1000.0 ) 
{
   int i,j;
   double res = 0.0;
   
   switch(num)
   {
    case 0:
            for(i = 1; i < in+1; i++)
               {
                  j = bar + i - 1;
                  res = (Open[j] - Open[j+1])/Open[j+1];
                  if(NormalizeDouble(res,3) > 0.0)
                     Dhid[num,i] = 1.0;
                  else
                     Dhid[num,i] = -1.0;   
               } 
            break;    
    case 1:
    case 2:
    case 3:        
            for(i = 1; i < in+1; i++)
               Dhid[num,i] = Dhid[0,i];
            break;   
               
   default: Print("   GetIn: num = ",num); //   
            break;                
   }
   return;
}

//----------------------------   ----------------------
void NetInit()
{
   int i,j, d,w, kf_r = 2;
      
   if(IsInit)
      return;
      
   ArrayResize(Dhid,hid); 
   ArrayInitialize(Dhid,0.0); 
   ArrayResize(Whid,hid);                                                
   ArrayInitialize(Whid,0.0); 
   
   ArrayResize(Dout,hid+1);                                                
   ArrayInitialize(Dout,0.0); 
   ArrayResize(Wout,hid+1);                                                
   ArrayInitialize(Wout,0.0);    
   
   ArrayResize(CorrHid,hid);                                             
   ArrayInitialize(CorrHid,0.0); 
   ArrayResize(SquarHid,hid);                                            
   ArrayInitialize(SquarHid,0.0); 
   
   ArrayResize(CorrOut,hid+1);                                             
   ArrayInitialize(CorrOut,0.0); 
   ArrayResize(SquarOut,hid+1);                                            
   ArrayInitialize(SquarOut,0.0);    
   
   MathSrand(TimeLocal());
   
   for(i = 0; i < hid; i++)                                          
     Dhid[i,0] = 1.0;
   Dout[0] = 1.0;  
     
   for(i = 0; i < hid; i++)
     for(j = 0; j < in+1; j++)
       Whid[i,j] = (2.0*MathRand() - 32767.0)/32767.0;
       
   for(i = 0; i < hid+1; i++)
     Wout[i] = (2.0*MathRand() - 32767.0)/32767.0;
     
   d = in+1;
   w = hid*d + hid+1;  
   Epoha = kf_r*w*w/d;                                                  //    
   IsInit = 1;                                                          //     
   
}    

void Guru(int train = 12)
{
   int i,j,k,n;
   double res, test;
   double er[100];                                            //  
   
   for(k = train; k > 0; k-- )                                   //  
      {
        ArrayInitialize(SquarOut,0.0); 
        ArrayInitialize(CorrOut,0.0);
        ArrayInitialize(CorrHid,0.0);
        ArrayInitialize(SquarHid,0.0);
        ArrayInitialize(er,0.0);
        res = 0.0; test = 0.0; 
        for(n = Epoha; n > 0; n--)                                     // 
          {
            res = OUT(n);                                              //   
            test = (Open[n-1] - Open[n])/Open[n];                      // n+1   
            res = (test - res) * (1 - res*res);                        //     
            
            for(i = 0; i < hid+1; i++)                                 //       
               {                                                       //  
                CorrOut[i]  += res * Dout[i];
                SquarOut[i] += CorrOut[i] * CorrOut[i];                //  
               }

            for(i = 0; i < hid; i++) 
                er[i] = res * (1 - Dout[i+1]*Dout[i+1]);               //    i-   
               
            for(i = 0; i < hid; i++)                                   //     
               for(j = 0; j < in+1; j++)                               // i-   
               {
                CorrHid[i,j]  += er[i] * Dhid[i,j];
                SquarHid[i,j] += CorrHid[i,j] * CorrHid[i,j];
               } 
           } 
        for(i = 0; i < hid+1; i++)  
         {
           if(NormalizeDouble(SquarOut[i],4) != 0.0)
           Wout[i] += CorrOut[i]/SquarOut[i];                          //    
         }  
             
        
        for(i = 0; i < hid; i++)                                       //   i-    
           for(j = 0; j < in+1; j++)
            if(NormalizeDouble(SquarHid[i,j],4) != 0.0)
              Whid[i,j] += CorrHid[i,j]/SquarHid[i,j];
      }   
}

void Scop()
{
   int i,j;
   
        Print("------------ Wout -----------------------");
        Print(Wout[0]," | ",Wout[1]," | ",Wout[2]," | ",Wout[3]); 
        Print("-----------------------------------------");
        Print("------------- Whid ----------------------"); 
        for(i = 0; i < in+1; i++)
        Print(Whid[0,i]," | ",Whid[1,i]," | ",Whid[2,i]," | ---| ",i);
}


